/*-
 * ~~~~~~licensing~~~~~~
 * test-producers
 * ==========
 * Copyright (C) 2020 - 2024 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.impl;

import ru.entaxy.platform.base.objects.EntaxyObject;
import ru.entaxy.platform.base.objects.factory.EntaxyFactory;

public class RefFieldInfoImpl extends FieldInfoImpl implements EntaxyFactory.RefFieldInfo{
	
	protected boolean isBackRef = false;
	protected boolean isRefByValueOnly = false;
	
	protected String refField = EntaxyObject.FIELDS.OBJECT_ID;
	
	/* EntaxyFactory.RefFieldInfo */
	
	@Override
	public boolean isBackRef() {
		return isBackRef;
	}

	@Override
	public boolean isRefByValueOnly() {
		return isRefByValueOnly;
	}

	@Override
	public String getRefField() {
		return refField;
	}

	/* builder */
	
	public RefFieldInfoImpl backRef(boolean backRefValue) {
		this.setBackRef(backRefValue);
		return this;
	};
	
	public RefFieldInfoImpl refByValueOnly(boolean refByValueOnlyValue) {
		this.setRefByValueOnly(refByValueOnlyValue);
		return this;
	};
	
	public RefFieldInfoImpl refField(String refFieldValue) {
		this.setRefField(refFieldValue);
		return this;
	};
	
	/* others */
	
	public void setBackRef(boolean isBackRef) {
		this.isBackRef = isBackRef;
	}

	public void setRefByValueOnly(boolean isRefByValueOnly) {
		this.isRefByValueOnly = isRefByValueOnly;
	}

	public void setRefField(String refField) {
		this.refField = refField;
	}

}
